// C Source File
// Created 27/07/2003; 13:26:37

#define USE_TI89              // Compile for TI-89
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher

#include <tigcclib.h>         // Include All Header Files

/*==================================================================================*/
//																																									//
//						Programme ralis sans aucune ligne d'assembleur!!!										//
//																																									//
/*==================================================================================*/

//-------------------------- Structure des Highscores ------------------------------//

typedef struct
  {
    char nom[8];
    long score;
  } HIGH_SCORES;

static HIGH_SCORES high[5]={
													{"Nul     ", 100},
													{"Nul     ", 90},
													{"Nul     ", 80},
													{"Nul     ", 70},
													{"Nul     ", 60},
};

//---------------------------- Dfinition des images -------------------------------//

static unsigned char titre[] = {0, 26, 0, 130,
0xFF,0xE3,0xFE,0x1F,0x80,0x3F,0x01,0xFE,0x00,0x1F,0x07,0xE3,0xF1,0xF9,0xE1,0xE0,0x00,0x7F,0xF3,0xFE,0x0F,0xC0,0x7F,0xE0,0xFF,0xE0,0x3F,0xE3,0xF1,0xF0,0xFC,0xF0,0xF0,0x00,0x3F,0xF1,0xFF,0x07,0xC0,0x7F,0xF8,0xFF,0xF8,0x3F,0xF8,0xF8,0xFC,0xFC,0xFC,0x78,0x00,0x1F,0xF8,0xFF,0x83,0xE0,0x3F,0xFC,0x7F,0xFC,0x3F,0xFC,0xFC,0x7E,0x7E,0x7E,0x7C,0x00,0x1F,0xFC,0x7F,0xC3,0xF0,0x7F,0x7E,0x3F,0xFE,0x3F,0x7E,0x7E,0x7F,0x3F,0x3E,0x3E,0x00,0x0F,0xC0,0x7F,0xE1,0xF8,0x3F,0xBF,0x1F,0x3F,0x1F,0xBF,0x3E,0x7F,0x3F,0x1F,0x9E,0x00,0x07,0xE0,0x7F,0xF0,0xF8,0x1F,0xBF,0x9F,0x9F,0x9F,0xBF,0x9F,0x3F,0x9F,0x1F,0xCF,0x00,0x07,0xE0,0x3F,0xF8,0xFC,0x1F,0xDF,0x8F,0x9F,0xCF,0xDF,0x9F,0xBF,0xCF,0x8F,0xCF,0x80,0x03,0xF0,0x3F,0xF8,0x7C,0x0F,0xDF,0xCF,0xCF,0xCF,0xDF,0xCF,0x9F,0xCF,0xCF,0xF7,0x80,0x03,0xF0,0x1F,0x7C,0x7E,0x0F,0xEF,0xC7,0xCF,0xEF,0xEF,0xCF,0x9F,0xEF,0xC7,0xF7,0xC0,0x01,0xFF,0x9F,0x7C,0x3E,0x07,0xEF,0xC7,0xEF,0xE7,0xEF,0xC7,0xEF,0xE7,0xC7,0xF7,0xC0,0x01,0xFF,0x9F,0x3C,0x3E,0x07,0xE0,0x07,0xE7,0xE7,0xEF,0xE7,0xEF,0xE7,0xC7,0xFF,0xC0,0x01,0xFF,0x9F,0x3C,0x3E,0x07,0xE0,0x07,0xE7,0xE7,0xEF,0xE7,0xEF,0xF7,0xE7,0xFF,0xC0,0x01,0xFF,0xBF,0x3E,0x3E,0x07,0xE0,0x07,0xE7,0xE7,0xEF,0xE7,0xEF,0xFF,0xC7,0xFF,0xC0,0x01,0xFF,0xBF,0x3E,0x3E,0x07,0xE0,0x07,0xE7,0xE7,0xEF,0xE7,0xEE,0xFF,0x87,0xFF,0xC0,0x03,0xF0,0x3E,0x7E,0x3E,0x07,0xEF,0xC7,0xCF,0xE7,0xEF,0xC7,0xFE,0xFF,0x87,0xBF,0xC0,0x03,0xF0,0x3E,0x7C,0x7E,0x0F,0xEF,0xC7,0xCF,0xCF,0xEF,0xC7,0xFE,0xFF,0x87,0xBF,0x80,0x03,0xF0,0x7F,0xFC,0x7C,0x0F,0xDF,0x8F,0xCF,0xCF,0xDF,0xCF,0xF9,0xFF,0x0F,0xBF,0x80,0x07,0xE0,0x7F,0xF8,0xFC,0x1F,0xDF,0x8F,0x9F,0x9F,0xDF,0x8F,0xF9,0xFF,0x0F,0x3F,0x00,0x07,0xE0,0xFF,0xFC,0xF8,0x1F,0xBF,0x1F,0x9F,0x9F,0xBF,0x0F,0xF3,0xFE,0x1F,0x3F,0x00,0x0F,0xC1,0xFF,0xF9,0xF0,0x3F,0x7F,0x1F,0x3F,0x1F,0x7F,0x0F,0xF3,0xFE,0x3E,0x7E,0x00,0x1F,0x83,0xF3,0xF3,0xFE,0x7F,0x7E,0x3F,0xFF,0x3F,0x7E,0x1F,0xE3,0xFC,0x3C,0xFE,0x00,0x3F,0x07,0xE7,0xF3,0xFE,0x7F,0xF8,0x7F,0xFC,0x3F,0xF8,0x3F,0xC7,0xF0,0x78,0xFC,0x00,0x3F,0x0F,0xE7,0xE7,0xFC,0x7F,0xF8,0xFF,0xF8,0x3F,0xF8,0x7F,0x8F,0xF0,0xF9,0xF8,0x00,0x7E,0x1F,0xC7,0xCF,0xF8,0x7F,0xC1,0xFF,0xE0,0x3F,0xE0,0xFF,0x1F,0xE1,0xF1,0xF0,0x00,0xFC,0x1F,0x8F,0x9F,0xF0,0x3F,0x01,0xFF,0x80,0x1F,0x00,0xFE,0x1F,0xC3,0xE1,0xE0,0x00};

static unsigned short balle[] = {0x1E00,0x7380,0x6780,0xCFC0,0x9FC0,0xFFC0,0xFFC0,0x7F80,0x7F80,0x1E00,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000};

static unsigned short bloc[] = {0xAAFF,0x55FF,0xABFE,0x57FD,0xAFFA,0x5FF5,0xBFEA,0x7FD5,0xFFAA,0xFF55,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000};

//----------------------------------------------------------------------------------//

void DrawBox(short x, short y, short width, short height, short mode)
{
	DrawClipRect(MakeWinRect(x, y, x+width, y+height), ScrRect, mode);
}

//----------------------------------------------------------------------------------//

void InputStr(long score, short choice)
{
	char nom[] = "        ";
	short key;
	short dim;
	
	dim = 0;
	
	FontSetSys(2);
	DrawStr(23, 50, "New Highscore!", 4);
	FontSetSys(1);
	DrawStr(40, 66, "Name:", 4);
	
	do
	{
		
		DrawStr(71, 66, nom, 4);
		key = ngetchx();
		
		if(key >= 18 && key <= 255 && dim < 8)
		{
			nom[dim] = key;
			dim++;
		}
		else if(key == KEY_BACKSPACE && dim > 0)
		{
			dim--;
			nom[dim] = 32;
		}
		else if(key == KEY_CLEAR)
		{
			memset(nom, 32, 8);
			dim = 0;
		}
		
	}while(key != KEY_ENTER);
	
	high[choice].score = score;
	memcpy(&high[choice].nom, &nom, sizeof(high[choice].nom));
	ScrRectFill(&(SCR_RECT){{23, 47, 135, 75}}, ScrRect, A_REVERSE);
}

//----------------------------------------------------------------------------------//

void DrawBlocs(short y, char *screen, short choice)
{
	short i;
	short y_blocs[4] = {};
	
	for(i = 0; i <= 3; i++)
	{
		y_blocs[i] = random(10);
	}
	
	if(choice > 1)
	{
		y_blocs[0] = y_blocs[1];
	}
	
	if(choice > 3)
	{
		y_blocs[2] = y_blocs[3];
	}
	
	for(i = 0; i <= 9; i++)
	{
		if(i != y_blocs[0] && i != y_blocs[1] && i != y_blocs[2] && i != y_blocs[3])
		{
			Sprite16(i*16, y, 16, bloc, screen, SPRT_OR);
		}
	}
	
}

//-------------------------------- Boucle du jeu -----------------------------------//

long jeu(short choice)
{	
	char *VScreen_1 = NULL; // Virtual Screen pour les blocs
	char *VScreen_2 = NULL; // Virtual Screen pour la balle
	short x_balle, y_balle, i;
	short liste_speed[] = {5000, 3000, 1500, 500, 0};
	long score;
	
	VScreen_1 = malloc(LCD_SIZE);
	VScreen_2 = malloc(LCD_SIZE);
	randomize();
	OSSetSR(0x0700);
	PortSet(VScreen_1, 239, 127);
		
	x_balle = 75;
	y_balle = 0;
	score = 29;
	
	memcpy(VScreen_1, LCD_MEM, LCD_SIZE);
	
	while(!_keytest(RR_ESC) && y_balle != -11)
	{
		
		if((score++)%40 == 0 && score > 120)
		{
			DrawBlocs(100, VScreen_1, choice);		 
		}	
				
		memcpy(VScreen_1, VScreen_1+30, 110*30); // Scrolle vers le haut
		
		if(_keytest(RR_RIGHT) && x_balle < 150)	// RIGHT
		{							
			x_balle++;																							
		}
		else if(_keytest(RR_LEFT) && x_balle > 0)	// LEFT
		{
			x_balle--;
		}		
		else if(_keytest(RR_APPS))
		{
			off();
		}
				
		if(((91-y_balle)%10 == score%10) && (GetPix(x_balle+3, y_balle+10) || GetPix(x_balle+4, y_balle+10) || GetPix(x_balle+5, y_balle+10)))
		{
			y_balle--;
		}
		else
		{
			if(y_balle < 90)
			{
				y_balle++;
			}
		}	
		
		memcpy(VScreen_2, VScreen_1, LCD_SIZE);
		Sprite16(x_balle, y_balle, 16, balle, VScreen_2, SPRT_OR);
		memcpy(LCD_MEM, VScreen_2, LCD_SIZE);
		
		for(i = 0; i <= liste_speed[choice]; i++)	// Boucle d'attente
		{
		}
			
	}
	
	score -= 29;
	free(VScreen_1);
	free(VScreen_2);
	PortRestore();
	OSSetSR(0x0000);
	FontSetSys(2);
	ScrRectFill(&(SCR_RECT){{31, 32, 129, 67}}, ScrRect, A_REVERSE);
	ScrRectFill(&(SCR_RECT){{0, 95, 159, 99}}, &(SCR_RECT){{0, 0, 159, 99}}, A_REVERSE);
	DrawBox(32, 33, 96, 33, 65);
	DrawBox(35, 36, 90, 27, 15);
	DrawStr(40, 40, "GAME OVER!", 4);
	FontSetSys(1);
	DrawStr(46, 53, "Score:", 4);
	printf_xy(82, 53, "%05lu", score);
	FontSetSys(0);
	DrawStr(0, 95, "Press [ENTER] to continue...", 4);
	while(ngetchx() != KEY_ENTER)
	{
	}
	
	return (score);
	
}

//-------------------- Fonction appele au lancement du jeu ------------------------//

void _main(void)
{
	FILE *fp = NULL;
	LCD_BUFFER screen;
	LCD_save(screen);
	const char *levels[] = {"VERY EASY", "EASY", "MEDIUM", "HARD", "VERY HARD"};
	short key, choice;
	long score;
	
	EM_moveSymFromExtMem(SYMSTR("falcsauv"), HS_NULL); // Dsarchive la variable 'falcsauv'
	if((fp = fopen("falcsauv", "r+b")))
	{
		fread(high, sizeof(high), 1, fp);
		fclose(fp);
	}
	
	choice = 0;
	score = 0;
	
	Debut:
	
	ClrScr();
	DrawBox(0, 0, 158, 92, 204);	
	BitmapPut(15, 5, titre, ScrRect, 4);
	FontSetSys(0);
	DrawStr(133, 32, "By Nul", 4);
	DrawBox(17, 45, 124, 32, 113);
	if(score > high[choice].score)
	{
		InputStr(score, choice);
	}
	FontSetSys(2);
	DrawStr(28, 50, "Level:", 4);
	FontSetSys(1);
	
	do
	{
		printf_xy(78, 52, "%-9s", levels[choice]);
		printf_xy(28, 66, "%05lu by %s", high[choice].score, high[choice].nom);
		
		key = ngetchx();
		
		if(key == KEY_ENTER)
		{
			score = jeu(choice);
			goto Debut;
		}
		else if(key == KEY_LEFT)
		{
			choice = choice == 0? 4: choice-1;
		}
		else if(key == KEY_RIGHT)
		{
			choice = choice == 4? 0: choice+1;
		}
	
	}while(key != KEY_ESC);
	
	fp = fopen("falcsauv", "w+b");
	fwrite(high, sizeof(high), 1, fp);
	fputc(0, fp);
	fputs("SAUV", fp);
	fputc(0, fp);
	fputc(OTH_TAG, fp);		
	fclose(fp);
	EM_moveSymToExtMem(SYMSTR("falcsauv"), HS_NULL); // Archive la variable 'falcsauv'
	LCD_restore(screen);
	ST_helpMsg("Falcdown by Nul v1.00");
}

//----------------------------------------------------------------------------------//